/*
 * JBoss, Home of Professional Open Source
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */

package org.jboss.cache.pojo.passivation;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jboss.cache.Fqn;
import org.jboss.cache.pojo.PojoCache;
import org.jboss.cache.pojo.PojoCacheFactory;
import org.jboss.cache.pojo.test.Address;
import org.jboss.cache.pojo.test.Person;
import org.testng.annotations.BeforeMethod;
import org.testng.annotations.Test;

/**
 * Basic PojoCache test case.
 *
 * @author Ben Wang
 */

 
public class TRGLocalTest
{
   Log log = LogFactory.getLog(org.jboss.cache.pojo.passivation.LocalTest.class);
   PojoCache cache_;
 


   @BeforeMethod(alwaysRun = true)
   protected void setUp() throws Exception
   {
      log.info("setUp() ....");
      String configFile = "META-INF/pojocache-passivation-service.xml";
      boolean toStart = false;
      cache_ = PojoCacheFactory.createCache(configFile, toStart);
      cache_.getCache().getRegion(Fqn.fromString("TEST"), true);
 

      cache_.start();
   }
 

   private Person createPerson(String name, int age)
   {
      Person p = new Person();
      p.setName(name);
      p.setAge(age);
      Address add = new Address();
      add.setZip(95123);
      add.setCity("San Jose");
      p.setAddress(add);
      return p;
   }
 
 
 
   
   public void testFindAgain1() throws Exception
   {
      log.info("testFindAgain() ....");
      String id = "person";
      Person joe = createPerson("Joe Black", 20);
         cache_.attach(id, joe);
      Thread.sleep(9100);// default is 3 seconds so joe should have been passivated.
//
//      assertNull("Node should be evicted ", ((CacheSPI<Object, Object>) cache_.getCache()).peek(new Fqn<String>(id), false));
//
//      Person p = (Person) cache_.find(id);
//
//      assertEquals("age ", 20, joe.getAge());
//      joe.setAge(30);
//      assertEquals("age ", 30, joe.getAge());
//
//      assertEquals("age ", p.getAge(), joe.getAge());
//
//      assertFalse("Instance not equal (this is known side effect) ", joe == p);

       
   }

    
   public static void main(String str[]) throws Exception{
	  TRGLocalTest test = new TRGLocalTest();
	  test.setUp();
      test.testFindAgain1();
	  String id ="person";
	  System.out.println("cache exists"+test.cache_.exists(new Fqn<String>(id)));
//	  Person p = (Person) test.cache_.find(id);
//	  System.out.println("person is "+p);
// 

   }
}
